#include <stdio.h>
#include "mpi.h"

#define ITERS 100
#define MSG_SIZE (128*1024)

int main(int argc, char ** argv)
{
	int rank, size, i;
	int dims[2], periodic[2], remain[2];
	MPI_Comm cart, row;
	int row_size;

	char * sbuf, * rbuf;
	double t1;

	char name[1000];
	int namelen;


	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

#if 0
	if (!rank) {
		MPI_Get_processor_name(name, &namelen);
		printf("Name: %s\n", name);
	}
#endif

	dims[0] = 0; dims[1] = 0;
	MPI_Dims_create(size, 2, dims);
	if (!rank) printf("Dims: %d %d\n", dims[0], dims[1]);

	periodic[0] = 0; periodic[1] = 0;
	MPI_Cart_create(MPI_COMM_WORLD, 2, dims, periodic, 0, &cart);

	remain[0] = 0; remain[1] = 1;
	MPI_Cart_sub(cart, remain, &row);
	MPI_Comm_size(row, &row_size);

	if (!rank) printf("Row size: %d\n", row_size);

	sbuf = (void *) malloc(MSG_SIZE);
	rbuf = (void *) malloc(MSG_SIZE * row_size);

	MPI_Barrier(MPI_COMM_WORLD);
	t1 = MPI_Wtime();
	for (i = 0; i < ITERS; i++)
		MPI_Alltoall(sbuf, MSG_SIZE, MPI_CHAR, rbuf, MSG_SIZE, MPI_CHAR, row);
	t1 = MPI_Wtime() - t1;

	if (!rank) printf("Time: %.3f\n", t1);

	MPI_Finalize();

	return 0;
}
