#####################################################################
#                                                                   #
#      (c) COPYRIGHT IBM CORP. 2006 ALL RIGHTS RESERVED.            #
#                                                                   #
#                LICENSED MATERIALS-PROPERTY OF IBM.                #
#                                                                   #
#####################################################################


MPE_DIR  = /home/chan/mpe_work/build_ibm_cross
MPE_LIBS = -L$(MPE_DIR)/lib -llmpe -lmpe

BGL_MPI_PATH = /bgl/BlueLight/ppcfloor/bglsys

MPI_CXX2C_LIBS = -L$(BGL_MPI_PATH)/lib -lcxxmpich.rts
MPI_LIBS = -L$(BGL_MPI_PATH)/lib -lmpich.rts -lmsglayer.rts -lrts.rts -ldevices.rts 
MPI_INC  = -I$(BGL_MPI_PATH)/include

BGL_ESSL_DIR = /opt/ibmmath/essl/4.2
ESSL_LIBS    = -L$(BGL_ESSL_DIR)/lib -lesslbg

BLRTS_PATH = /opt/ibmcmp/xlf/bg/10.1
XLMATH_LIBS  = -L$(BLRTS_PATH)/blrts_lib -lxlf90 -lxlfmath -lxl -lm

MATH_LIBS   = $(ESSL_LIBS) $(XLMATH_LIBS)

CCC_FLAGS = -qarch=440 -O3 -g -qsource  -DMPICH_SKIP_MPICXX -DBGL3DFFT_ENABLE_FLOAT  $(MPI_INC) -I./../inc/ -I./ -I./../obj/  

CCC_XLC = blrts_xlC  

OBJ = bgl3dfft.tst.o  
# OBJ_BGL3DFFT_DOUBLE = ../obj/sbgl3dfft.o
OBJ_BGL3DFFT_FLOAT = ../obj/sbgl3dfft.o

TARGETS = fft.rts fft.log fft.xlog

.cpp.o:  $(OBJ)
	$(CCC_XLC) $(CCC_FLAGS) -c $<

default: $(TARGETS)

fft.rts: $(OBJ)
	$(CCC_XLC) -o $@ $(OBJ) $(OBJ_BGL3DFFT_FLOAT) $(MPI_LIBS) $(MATH_LIBS)

fft.log: $(OBJ)
	$(CCC_XLC) -o $@ $(OBJ) $(OBJ_BGL3DFFT_FLOAT) $(MPE_LIBS) $(MPI_LIBS) $(MATH_LIBS)

fft.xlog: $(OBJ)
	$(CCC_XLC) -o $@ $(OBJ) $(OBJ_BGL3DFFT_FLOAT) -L$(MPE_DIR)/lib $(MPI_CXX2C_LIBS) $(MPE_LIBS)  $(MPI_LIBS) $(MATH_LIBS)

clean:
	rm -f *.o

realclean: clean
	rm -f $(TARGETS)
