#ifdef SCALAR
subroutine correc(ux_k,uy_k,uz_k,tha_k,F_ux_k,F_uy_k,F_tha_k,ux_ktemp,uy_ktemp,tha_ktemp,uij_k)
#else
subroutine correc(ux_k,uy_k,uz_k,F_ux_k,F_uy_k,ux_ktemp,uy_ktemp,uij_k)
#endif

  use com

  implicit none

  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: ux_k,uy_k,uz_k
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: ux_ktemp,uy_ktemp
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: F_ux_k,F_uy_k
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: uij_k
#ifdef SCALAR
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: tha_k
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: tha_ktemp
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: F_tha_k
#endif

	
!-------Rate of change
#ifdef SCALAR 
  call rhs_sc(ux_k,uy_k,uz_k,tha_k,F_ux_k,F_uy_k,F_tha_k,uij_k)
#else
  call rhs_sc(ux_k,uy_k,uz_k,F_ux_k,F_uy_k,uij_k)
#endif

!-------Transform the fields back to Fourier--------------------
  call p3dfft_ftran_r2c (ux_k,ux_k,flg_inplace)
  call p3dfft_ftran_r2c (uy_k,uy_k,flg_inplace)

  ux_k=ux_k*real(fak)
  uy_k=uy_k*real(fak)

#ifdef SCALAR
  call p3dfft_ftran_r2c (tha_k,tha_k,flg_inplace)

  tha_k=tha_k*real(fak)
#endif

!-------Corrector step 
!       All integrating factors already considered
!       in predictor step-> module predic.f !!!!!!
	
  do z=1,nzhp

    call masks(z)

    do y=jjstart,jjend

     do x=iistart,iiend
	   
      ux_k(x,y,z)=ux_ktemp(x,y,z)*mask(x,y)+ &
	          dt2*F_ux_k(x,y,z)*mask(x,y)

      uy_k(x,y,z)=uy_ktemp(x,y,z)*mask(x,y)+ &
	          dt2*F_uy_k(x,y,z)*mask(x,y)
	                
#ifdef SCALAR	                
      tha_k(x,y,z)=tha_ktemp(x,y,z)*mask(x,y)+ &
	           dt2*F_tha_k(x,y,z)*mask(x,y)
#endif	                
      enddo
    enddo  
  enddo   

end subroutine correc
