subroutine enfsymm(A)

!---------------------------------------------------------------------
!       Enforce symmetry due to reality condition at plane kx=0
!---------------------------------------------------------------------	
  use p3dfft_var
  use com

  implicit none

  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: A  
  complex(mytype), dimension(1:nz,1:ny) :: u01
  integer, dimension(MPI_STATUS_SIZE,jjsize) :: mpi_status
  integer, dimension(jjsize) :: request
  integer :: ydest,yrecv,destid,recvid,nrequest
	
!-------Case ky=0 (due to div u=0)-------------------	
  if (taskid.eq.0) then
    do z=1,nz
      A(iistart,jjstart,z)=(0.,0.)
    enddo	  
  endif

!-------Case ky ne 0---------------------------------
!-------First half
  nrequest = 0

  if (taskid.le.jproc/2-1) then
  
    do y=jjstart,jjend

      if (y.gt.1) then
        u01(1,y)   =A(iistart,y,1)
        u01(nzhp,y)=A(iistart,y,nzhp)
        do z=2,nz/2
	  u01(z,y)     = A(iistart,y,z)
	  u01(nz+2-z,y)=-A(iistart,y,z)	
        enddo

        ydest  = ny+2-y
        destid = (ydest-1)/jjsize
        nrequest = nrequest + 1

	! print*,taskid,'send',y,'->',ydest,' at ',destid

        call MPI_Isend(u01(1,y),nz,MPI_COMPLEX,destid,0,MPI_COMM_WORLD,request(nrequest),ierr)

      endif
    enddo

    call MPI_Waitall(nrequest,request,mpi_status,ierr)

  else if ((taskid.lt.jproc).and.(taskid.ge.jproc/2)) then

    do y=jjend,jjstart,-1

      if (y.gt.nyhp) then
        yrecv  = ny+2-y
        recvid = (yrecv-1)/jjsize
        nrequest = nrequest + 1

	! print*,taskid,'recv',y,'<-',yrecv,' from ',recvid

        call MPI_Irecv(u01(1,y),nz,MPI_COMPLEX,recvid,0,MPI_COMM_WORLD,request(nrequest),ierr)

      endif
    enddo

    call MPI_Waitall(nrequest,request,mpi_status,ierr)

    do y=jjstart,jjend
      if (y.gt.nyhp) then
	A(iistart,y,1)=conjg(u01(1,y))
	do z=2,nz
	  A(iistart,y,z)=conjg(u01(nz+2-z,y))
	enddo
      end if
    enddo

  endif

end subroutine enfsymm
