#ifdef SCALAR
subroutine v_inpk1(ux_k,uy_k,uz_k,tha_k,ipic)
#else
subroutine v_inpk1(ux_k,uy_k,uz_k,ipic)
#endif

!---------------------------------------------------------------------
!       Input using different files for different pencils and snapshots
!---------------------------------------------------------------------	
  use p3dfft_var
  use com

  implicit none

  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: ux_k,uy_k,uz_k
#ifdef SCALAR
  complex(mytype), dimension(iistart:iiend,jjstart:jjend,1:nz) :: tha_k
#endif


#ifdef LAGRANGE
  character(80) :: tracername
#endif	
  integer :: ipic
  character(80) :: uxname
  character(80) :: uyname
  character(80) :: uzname

#ifdef SCALAR
  character(80) :: thaname
#endif	
  
  WRITE(uxname,'("daten/ux",I5.5,".",I3.3)')taskid,ipic
  WRITE(uyname,'("daten/uy",I5.5,".",I3.3)')taskid,ipic
  WRITE(uzname,'("daten/uz",I5.5,".",I3.3)')taskid,ipic
        
  OPEN(10,FILE=TRIM(uxname),FORM='unformatted')
  OPEN(12,FILE=TRIM(uyname),FORM='unformatted')
  OPEN(14,FILE=TRIM(uzname),FORM='unformatted')
                
  read(10)(((ux_k(x,y,z),x=iistart,iiend),y=jjstart,jjend),z=1,nz)
  read(12)(((uy_k(x,y,z),x=iistart,iiend),y=jjstart,jjend),z=1,nz)
  read(14)(((uz_k(x,y,z),x=iistart,iiend),y=jjstart,jjend),z=1,nz)
        
  CLOSE(10)
  CLOSE(12)
  CLOSE(14)

#ifdef SCALAR
  WRITE(thaname,'("daten/tha",I5.5,".",I3.3)')taskid,ipic
        
  OPEN(16,FILE=TRIM(thaname),FORM='unformatted')
  read(16)(((tha_k(x,y,z),x=iistart,iiend),y=jjstart,jjend),z=1,nz)
  CLOSE(16)
#endif	

#ifdef LAGRANGE

!-------Input
  if (taskid.eq.0) then
    WRITE(tracername,'("daten/tracerpos.",I3.3)')ipic
    open(19,FILE=TRIM(tracername))
    do it=1,nt 
      read(19,*)xt(it),yt(it),zt(it)
    enddo
    close(19)
  endif
	
!-------Distribute to other CPU's
  call MPI_BCAST(xt,nt,MPI_REAL,0,MPI_COMM_WORLD,ierr)
  call MPI_BCAST(yt,nt,MPI_REAL,0,MPI_COMM_WORLD,ierr)
  call MPI_BCAST(zt,nt,MPI_REAL,0,MPI_COMM_WORLD,ierr)
                       	
#endif	

end subroutine v_inpk1

