typedef struct {
    MPI_Datatype  sendtype;
    MPI_Datatype  recvtype;
    MPI_Comm      comm;
    int           a2a_count;
    MPI_Aint      send_extent; 
    MPI_Aint      recv_extent; 
    int           comm_size;
    int           comm_rank;
    int           req_max;
    int           req_count;
    MPI_Request  *req_array;
    MPI_Status   *stat_array;
} IA2A_Data_t;

void IA2A_Init( MPI_Datatype sendtype, MPI_Datatype recvtype,
                MPI_Comm comm, int a2a_count );

void IA2A_Finalize( void );

void IA2A_Post( void *sendbuf, int *sendcnts, int *sdispls,
                void *recvbuf, int *recvcnts, int *rdispls );

void IA2A_Fence( void );
