
#include "ia2a_conf.h"

#if defined(F77_NAME_UPPER)

#define ia2a_init_ IA2A_INIT
#define ia2a_finalize_ IA2A_FINALIZE
#define ia2a_post_ IA2A_POST
#define ia2a_fence_ IA2A_FENCE

#elif defined(F77_NAME_LOWER_2USCORE)

#define ia2a_init_ ia2a_init__
#define ia2a_finalize_ ia2a_finalize__
#define ia2a_post_ ia2a_post__
#define ia2a_fence_ ia2a_fence__

#elif defined(F77_NAME_LOWER)

#define ia2a_init_ ia2a_init
#define ia2a_finalize_ ia2a_finalize
#define ia2a_post_ ia2a_post
#define ia2a_fence_ ia2a_fence

#endif


#include "mpi.h"
#include "ia2a.h"

/* A temporary until we can make this do
   MPIR_F_PTR(a) (((a)==(MPIR_F_MPI_BOTTOM))?MPI_BOTTOM:a)
*/
#define MPIR_F_PTR(a) (a)

void ia2a_init_( MPI_Fint *sendtype, MPI_Fint *recvtype,
                 MPI_Fint *comm, MPI_Fint *a2a_count );
void ia2a_init_( MPI_Fint *sendtype, MPI_Fint *recvtype,
                 MPI_Fint *comm, MPI_Fint *a2a_count )
{
    IA2A_Init( MPI_Type_f2c(*sendtype), MPI_Type_f2c(*recvtype),
               MPI_Comm_f2c(*comm), *a2a_count );
}

void ia2a_finalize_( void );
void ia2a_finalize_( void )
{
    IA2A_Finalize();
}

void ia2a_post_( void *sendbuf, MPI_Fint *sendcnts, MPI_Fint *sdispls,
                 void *recvbuf, MPI_Fint *recvcnts, MPI_Fint *rdispls );
void ia2a_post_( void *sendbuf, MPI_Fint *sendcnts, MPI_Fint *sdispls,
                 void *recvbuf, MPI_Fint *recvcnts, MPI_Fint *rdispls )
{
    IA2A_Post( MPIR_F_PTR(sendbuf), sendcnts, sdispls,
               MPIR_F_PTR(recvbuf), recvcnts, rdispls );
}

void ia2a_fence_( void );
void ia2a_fence_( void )
{
    IA2A_Fence();
}
