#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"
#include "ia2a.h"

int main( int argc, char *argv[] )
{
    int *sendbuf, *recvbuf;
    int *sendcnts, *recvcnts;
    int *sdispls, *rdispls;
    int a2a_count, comm_size, idx;

    a2a_count = 2;

    MPI_Init( &argc, &argv );
    MPI_Comm_size( MPI_COMM_WORLD, &comm_size );

    sendcnts = (int *) malloc( comm_size * sizeof(int) );
    recvcnts = (int *) malloc( comm_size * sizeof(int) );
    sdispls  = (int *) malloc( comm_size * sizeof(int) );
    rdispls  = (int *) malloc( comm_size * sizeof(int) );

    for ( idx = 0; idx < comm_size; idx++ ) {
        sendcnts[idx] = 1000;
        sdispls[idx]  = 0;
        recvcnts[idx] = 1000;
        rdispls[idx]  = idx * 1000;
    }

    sendbuf = (int *) malloc( a2a_count * 1000 * sizeof(int) );
    recvbuf = (int *) malloc( a2a_count * 1000 * comm_size * sizeof(int) );

    IA2A_Init( MPI_INT, MPI_INT, MPI_COMM_WORLD, a2a_count );
    for ( idx = 0; idx < a2a_count; idx++ ) {
        IA2A_Post( &(sendbuf[idx*1000]), sendcnts, sdispls,
                   &(recvbuf[idx*1000*comm_size]), recvcnts, rdispls );
    }
    IA2A_Fence();
    IA2A_Finalize();

    printf("IA2A C Done!\n");

    MPI_Finalize();

    return 0;
}
