      program test
      implicit none

      include 'mpif.h'

      integer, dimension(:), allocatable :: sendbuf, recvbuf
      integer, dimension(:), allocatable :: sendcnts, recvcnts
      integer, dimension(:), allocatable :: sdispls, rdispls
      integer  a2a_count, comm_size, idx, ierr

      a2a_count = 2

      call MPI_Init( ierr )
      call MPI_Comm_size( MPI_COMM_WORLD, comm_size, ierr )

      allocate( sendcnts( comm_size ) )
      allocate( recvcnts( comm_size ) )
      allocate( sdispls( comm_size ) )
      allocate( rdispls( comm_size ) )

      do idx = 1, comm_size
          sendcnts(idx) = 1000
          recvcnts(idx) = 1000
          sdispls(idx)  = 0
          rdispls(idx)  = (idx-1) * 1000
      enddo

      allocate( sendbuf( a2a_count * 1000 ) )
      allocate( recvbuf( a2a_count * 1000 * comm_size ) )

      call IA2A_Init( MPI_INTEGER, MPI_INTEGER,
     &                MPI_COMM_WORLD, a2a_count )
      do idx = 0, a2a_count-1
          call IA2A_Post( sendbuf(idx*1000),
     &                    sendcnts, sdispls,
     &                    recvbuf(idx*1000*comm_size),
     &                    recvcnts, rdispls )
      enddo
      call IA2A_Fence()
      call IA2A_Finalize()

      write(6,*) 'IA2A Done!'

      call MPI_Finalize( ierr )

      end
